﻿from . import active_session


class Window:
    _id: int

    @staticmethod
    def check_id(path, window_id: int = 0):
        if f'wnd[{window_id}]' not in path:
            path = path.replace('wnd[0]', f'wnd[{window_id}]')
        return path

    @classmethod
    def set_id(cls, window_id: int = 0):
        cls._id = window_id

    @classmethod
    def get_id(cls):
        return cls._id

    @classmethod
    def get_string(cls):
        return f'wnd[{cls._id}]'

    def get_title(self, window_id: int = 0):
        if self.exists(window_id):
            return active_session.session.findById(f'wnd[{window_id}]').text
        else:
            return None

    @staticmethod
    def close(window_id: int = 0):
        active_session.session.findById(f'wnd[{window_id}]').close()

    @staticmethod
    def exists(window_id: int = 0):
        try:
            active_session.session.findByID(f'wnd[{window_id}]')
            return True
        except Exception as ex:
            print(ex)
            return False

    def exists_go_on(self, window_id: int, seconds_to_wait: int = 2):
        raise NotImplementedError

    def get_contents(self, window_id: int = 0):
        """
            # lintReihenzaehler = 1
            # Do While
            # SapGui_Elemente.EF("MESSTXT" + cstr(lintReihenzaehler), FensterID).exist(2) = True
            # Inhalt = Inhalt & SapGui_Elemente.EF("MESSTXT" + cstr(lintReihenzaehler), FensterID).getRoProperty("value") & " "
            # lintReihenzaehler = lintReihenzaehler + 1
            """
        raise NotImplementedError

    def active_go_on(self, window_id: int = 0):
        """
            # Set lobjReferenz = SapGui_Elemente.Fenster(FensterID)
            # If lobjReferenz.exist(2) = True Then
            # If lobjReferenz.SapGuiButton("containername:=tbar\[0\]", "guicomponenttype:=40", "name:=btn\[0\]").exist(2) = True Then
            # lobjReferenz.SapGuiButton("containername:=tbar\[0\]", "guicomponenttype:=40", "name:=btn\[0\]").Click
            # If lobjReferenz.SapGuiButton("guicomponenttype:=40", "name:=SPOP-OPTION1", "type:=GuIButton").exist(2) = True Then
            # lobjReferenz.SapGuiButton("guicomponenttype:=40", "name:=SPOP-OPTION1", "type:=GuIButton").Click
            """
        raise NotImplementedError

    def is_active_close(self, window_id: int = 0):
        raise NotImplementedError
        # If SapGui_Fenster.aktiv(FensterID) = true Then
        # SapGui_Elemente.Fenster(FensterID).close

    def is_active(self, window_id: int = 0):
        raise NotImplementedError
        # aktiv = False
        # If SapGui_Elemente.Fenster(FensterID).Exist = True Then
        # aktiv = True
